package s.j;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Hashtable;

import org.ksoap2.SoapEnvelope;
import org.ksoap2.serialization.SoapObject;
import org.ksoap2.serialization.SoapSerializationEnvelope;
import org.ksoap2.transport.HttpTransportSE;

import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.view.View;
import android.widget.TextView;
import android.widget.EditText;
import bib.*;

public class Sa1ClieActivity extends Activity {
    String urlServ = "", targetNamespace = "";
    boolean isDotNet = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_sa1_clie);
    }

    public void onClickExec(View view) {
        urlServ = ((EditText) findViewById(R.id.urlserv)).getText()
                .toString().trim();
        Hashtable<String, String> url = Hurl.hurl(urlServ);
        urlServ = "http://" + url.get("host") + ":" + url.get("port");
        if (url.get("path").length() > 0)
            urlServ += "/" + url.get("path");
        if (urlServ.endsWith("/"))
        targetNamespace = ((EditText) findViewById(R.id.targetnamespace)).getText()
                .toString().trim();
        isDotNet = urlServ.endsWith(".asmx");
        AsyncTask<String, Void, String> task = new AsyncTask<String, Void, String>() {

            @Override
            protected String doInBackground(String... strings) {
                String resp = "";
                SoapSerializationEnvelope envelope = null;
                HttpTransportSE serviciu = null;
                SoapObject request = null;
                try {
                    // Daca se cheama serviciul Python, aceasta secventa
                    // nu merge in aceeasi functie doInBackground. 
                    // Sa se faca eventual inainte!
                    if (targetNamespace.length() == 0) {
                        HttpURLConnection u = (HttpURLConnection) (new URL(
                                urlServ + "?wsdl")).openConnection();
                        u.setDefaultUseCaches(false);
                        u.setUseCaches(false);
                        u.connect();
                        BufferedReader in = new BufferedReader(
                                new InputStreamReader(u.getInputStream()));
                        for (;;) {
                            String linie = in.readLine();
                            if (linie == null)
                                break;
                            int i = linie.indexOf("targetNamespace");
                            if (i < 0)
                                continue;
                            i = linie.indexOf("\"", i);
                            if (i < 0)
                                continue;
                            linie = linie.substring(i + 1);
                            targetNamespace = linie.substring(0,
                                    linie.indexOf("\""));
                        }
                        in.close();
                        u.disconnect();
                    }
                    serviciu = new HttpTransportSE(urlServ);
                    envelope = new SoapSerializationEnvelope(SoapEnvelope.VER11);
                    envelope.dotNet = isDotNet;
                    resp += "Client SOAP Android: " + serviciu
                            + "\ntargetNamespace:" + targetNamespace + "\n";

                    request = new SoapObject(targetNamespace, "ping");
                    envelope.setOutputSoapObject(request);
                    serviciu.call(targetNamespace + "ping", envelope);
                    resp += "ping: " + envelope.getResponse() + "\n";

                    request = new SoapObject(targetNamespace, "upcase");
                    request.addProperty("arg0", "negru");
                    envelope.setOutputSoapObject(request);
                    serviciu.call(targetNamespace + "upcase", envelope);
                    resp += "upcase: negru = " + envelope.getResponse()
                            + "\n";
                    request = new SoapObject(targetNamespace, "add");
                    request.addProperty("arg0", 66);
                    request.addProperty("arg1", 75);
                    envelope.setOutputSoapObject(request);
                    serviciu.call(targetNamespace + "add", envelope);
                    resp += "add: 66 + 75 = " + envelope.getResponse()
                            + "\n";

                    request = new SoapObject(targetNamespace, "ping");
                    envelope.setOutputSoapObject(request);
                    serviciu.call(targetNamespace + "ping", envelope);
                    resp += "ping: " + envelope.getResponse() + "\n";

                    return resp;
                } catch (Exception e) {
                    StringWriter sw = new StringWriter();
                    PrintWriter pw = new PrintWriter(sw);
                    e.printStackTrace(pw);
                    return resp + "ERROR:\n" + sw.toString();
                }

            }

            @Override
            protected void onPostExecute(String res) {
                ((TextView) findViewById(R.id.res)).setText(res);
            }
        };
        task.execute("Execute");
    }
}
